<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- bootstrap link -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- link data table -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <!-- font Awesome -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
    <!-- modal -->
    <title>Task 530</title>
</head>

<body>
    <!-- Vùng header -->
    <div class="container">
        <div class="text-center">
            <h3>DANH SÁCH SẢN PHẨM</h3>
        </div>
        <div class="form-group jumbotron">
            <form>
                <div class="row text-center">
                    <div class="col-lg-4 form-group">
                        <label class="d-inline-block" for="select-country">
                            <large><strong>Quốc gia</strong></large>
                        </label>
                        <select class="form-control d-inline-block" name="select-contry" id="select-country"
                            style="width: auto;">
                            <option value="0">--Chọn quốc gia--</option>
                            <option value="1">Việt Nam</option>
                            <option value="2">Mỹ</option>
                            <option value="3">Trung Quốc</option>
                            <option value="4">Đức</option>
                            <option value="5">Singapore</option>
                            <option value="6">Nhật Bản</option>
                            <option value="7">Hàn Quốc</option>
                            <option value="8">Tây Ban Nha</option>
                            <option value="9">Italia</option>
                            <option value="10">Pháp</option>
                        </select>
                    </div>
                    <div class="col-lg-6">
                        <label class="d-inline-block" for="select-product-types">
                            <large><strong>Nhóm sản phẩm</strong></large>
                        </label>
                        <select class="form-control d-inline-block" name="select-category"
                            id="select-category" style="width: auto;">
                            <option value="0">--Chọn nhóm sản phẩm--</option>
                            <option value="1">Thời trang</option>
                            <option value="2">Điện tử, Laptop</option>
                            <option value="3">Đồng Hồ</option>
                            <option value="4">Điện thoại thông minh</option>
                            <option value="5">Thiết bị vệ sinh</option>
                            <option value="6">Đồ thể thao</option>
                            <option value="7">Sản phẩm làm đẹp</option>
                            <option value="8">Xe cộ</option>
                            <option value="9">Thiết bị giải trí</option>
                            <option value="10">Thiết bị khác</option>
                        </select>
                    </div>
                    <div class="col-lg-2">
                        <button type="button" class="btn btn-success" id="btn-filter">Lọc sản phẩm</button>
                    </div>
                </div>
            </form>
        </div>
        <div class="form-group">
            <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; Thêm user</button>
        </div>
    </div>
    <!-- Vouche Data Table -->
    <div class="container">
        <table class="table table-bordered table-striped table-hover" id="products-table">
            <thead class="bg-info">
                <tr>
                    <th>STT</th>
                    <th>Mã sản phẩm</th>
                    <th>Tên sản phẩm</th>
                    <th>Nhóm sản phẩm</th>
                    <th>Quốc gia</th>
                    <th>Ảnh đại diện</th>
                    <th>Giá bán</th>
                    <th>Giá giảm</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
    <!-- div modal update product -->
    <div>>
        <div id="edit-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Thông tin sản phẩm</h5>
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row">
                                <div class="col-sm-8">
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="input-product-codes">Product Code</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input type="text" id="input-product-code" name="ProductCode"
                                                placeholder="ProductCode..." class="form-control">
                                        </div>
                                    </div>
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="input-product-name">Product Name</label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input type="text" id="input-product-name" name="ProductName"
                                                placeholder="ProductName..." class="form-control">
                                        </div>
                                    </div>

                                </div>
                                <div class="col-sm-4">
                                    <div class="row form-group product-image">

                                    </div>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-description">Description</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-description" name="ProductDes"
                                        placeholder="Discription..." class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-country">Country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select class="form-control" name="UserCountry" id="modal-select-country">
                                        <option value="0">Select country</option>
                                        <option value="1">Việt Nam</option>
                                        <option value="2">Mỹ</option>
                                        <option value="3">Trung Quốc</option>
                                        <option value="4">Đức</option>
                                        <option value="5">Singapore</option>
                                        <option value="6">Nhật Bản</option>
                                        <option value="7">Hàn Quốc</option>
                                        <option value="8">Tây Ban Nha</option>
                                        <option value="9">Italia</option>
                                        <option value="10">Pháp</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-category">Categories</label>
                                </div>
                                <div class="col-sm-8">
                                    <select class="form-control" name="UserCustomerType" id="modal-select-category">
                                        <option value="0">Select Categories</option>
                                        <option value="1">Thời trang</option>
                                        <option value="2">Điện tử, Laptop</option>
                                        <option value="3">Đồng Hồ</option>
                                        <option value="4">Điện thoại thông minh</option>
                                        <option value="5">Thiết bị vệ sinh</option>
                                        <option value="6">Đồ thể thao</option>
                                        <option value="7">Sản phẩm làm đẹp</option>
                                        <option value="8">Xe cộ</option>
                                        <option value="9">Thiết bị giải trí</option>
                                        <option value="10">Thiết bị khác</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-sm-4">
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="input-product-id"><small>Product Id</small></label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input type="text" id="input-product-id" name="ProductId"
                                                placeholder="Id..." class="form-control">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-sm-4">
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="input-product-price"><small>Price</small></label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input type="text" id="input-product-price" name="ProductPrice"
                                                placeholder="Price..." class="form-control">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-sm-4">
                                    <div class="row form-group">
                                        <div class="col-sm-4">
                                            <label for="input-product-discount"><small>Discount</small></label>
                                        </div>
                                        <div class="col-sm-8">
                                            <input type="text" id="input-product-discount" name="ProductDiscount"
                                                placeholder="Discount..." class="form-control">
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">

                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    $(document).ready(function () {
        // link API
        const gBASE_URL = "https://63b401c1ea89e3e3db539072.mockapi.io/api/v1/";

        const gTABLE_NAME_COL = ["stt", "productCode", "productName", "categoryId", "countryId", "imagUrl", "price", "discountPrice", "action"]
        const gSTT_COL = 0;
        const gPRODUCT_CODE_COL = 1;
        const gPRODUCT_NAME_COL = 2;
        const gPRODUCT_CATEGORY_COL = 3;
        const gCOUNTRY_COL = 4;
        const gPHOTO_COL = 5;
        const gPRICE_COL = 6;
        const gDISCOUNT_COL = 7;
        const gACTION_COL = 8;
        var gStt = 0;
        var gProductList = {
            productCode: "",
            productName: "",
            categoryId: "",
            countryId: "",
            imagUrl: "",
            price: "",
            discountPrice: "",
          }
        var gProductCategoryList = {
            id: "",
            categoryName: ""
        };
        var gCountryList = {
            id: "",
            countryCode: "",
            countryName: ""
        };
        var gProductId = 0;
        var gProductTable = $("#products-table").DataTable({
            paging: false,
            columns: [
                { data: gTABLE_NAME_COL[gSTT_COL] },
                { data: gTABLE_NAME_COL[gPRODUCT_CODE_COL] },
                { data: gTABLE_NAME_COL[gPRODUCT_NAME_COL] },
                { data: gTABLE_NAME_COL[gPRODUCT_CATEGORY_COL] },
                { data: gTABLE_NAME_COL[gCOUNTRY_COL] },
                { data: gTABLE_NAME_COL[gPHOTO_COL] },
                { data: gTABLE_NAME_COL[gPRICE_COL] },
                { data: gTABLE_NAME_COL[gDISCOUNT_COL] },
                { data: gTABLE_NAME_COL[gACTION_COL] },
            ],
            columnDefs: [
                {
                    targets: gPHOTO_COL,
                    render: function (data) {
                        return `<img src="${data}" style="width: 150px">`
                    }
                },
                {
                    targets: gSTT_COL,
                    render: function () {
                        return gSTT++;
                    }
                },
                {
                    targets: gACTION_COL,
                    defaultContent: ` <img class="edit-product" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                                <img class="delete-product" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                                `
                },
                {
                    targets: gPRODUCT_CATEGORY_COL,
                    render: renderCategoryIdToCategoryName
                },
                {
                    targets: gCOUNTRY_COL,
                    render: renderCountryIdToCountryName
                }
            ]
        })
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        onPageLoading();
        //thực thi khi ấn nút edit product:
        $("#products-table").on("click", ".edit-product", function () {
            gProductId = onBtnEditProductClick(this);
            console.log(gProductId);
            getProductById(gProductId)

        })
        //thực thi khi ấn nút lọc sản phẩm:
        $(document).on("click", "#btn-filter", function() {
            console.log("lọc")
        })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // hàm load trang
        function onPageLoading() {
            getProductList();
            getProductCategoryList();
            getCountryList();
        }
        //hàm ấn nút edit product:
        function onBtnEditProductClick(paramEditBtn) {
            var vTableRow = $(paramEditBtn).parents("tr");
            var vDataTableRow = gProductTable.row(vTableRow);
            var vProductId = vDataTableRow.data().id;
            return vProductId
        }


        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //hàm lấy danh sách sản phẩm:
        function getProductList() {
            $.ajax({
                url: gBASE_URL + "/products/",
                type: "GET",
                success: function (paramRes) {
                    console.log(paramRes);
                    loadProductListIntoTable(paramRes)
                },
                error: function (paramError) {
                    console.log(paramError.responseText)
                }
            })
        };
        function loadProductListIntoTable(paramProductList) {
            gSTT = 1;
            gProductTable.clear();
            gProductTable.rows.add(paramProductList);
            gProductTable.draw();
        }
        //hàm get category of product list:
        function getProductCategoryList() {
            $.ajax({
                url: gBASE_URL + "/categories/",
                type: "GET",
                success: function (paramRes) {
                    gProductCategoryList = paramRes;
                },
                error: function (paramError) {
                    console.log(paramError.responseText)
                }
            });
        };
        //hàm render id nhóm sản phẩm thành tên nhóm sản phẩm:
        function renderCategoryIdToCategoryName(paramCategoryId) {
            "use strict";
            var vCategoryName = "CHUA_CO_TEN";
            var vFound = false;
            var vViTriHienTai = 0;
            while (!vFound && vViTriHienTai < gProductCategoryList.length) {
                if (gProductCategoryList[vViTriHienTai].id == paramCategoryId) {
                    vCategoryName = gProductCategoryList[vViTriHienTai].categoryName;
                    vFound = true;
                } else {
                    vViTriHienTai++
                }
            }
            return vCategoryName;
            console.log(vCategoryName)
        };

        //hàm get country list:
        function getCountryList() {
            $.ajax({
                url: gBASE_URL + "/countries/",
                type: "GET",
                success: function (paramResponse) {
                    gCountryList = paramResponse;
                },
                error: function (paramError) {
                    console.log(paramError.responseText)
                }
            });
        };
        //hàm render id country thành tên country:
        function renderCountryIdToCountryName(paramCountryId) {
            "use strict";
            var vCountryName = "CHUA_CO_TEN";
            var vFound = false;
            var vViTriHienTai = 0;
            while (!vFound && vViTriHienTai < gCountryList.length) {
                if (gCountryList[vViTriHienTai].id == paramCountryId) {
                    vCountryName = gCountryList[vViTriHienTai].countryName;
                    vFound = true;
                } else {
                    vViTriHienTai++
                }
            }
            return vCountryName;
            console.log(vCountryName)
        };
        //hàm get product by id
        function getProductById(paramProductId) {
            $.ajax({
                url: gBASE_URL + "/products/" + paramProductId,
                type: "GET",
                success: function (paramProductObj) {
                    console.log(paramProductObj)
                    showProductInfoIntoEditModal(paramProductObj)
                },
                error: function (paramError) {
                    console.log(paramError.responseText)
                }
            })
            $("#edit-modal").modal("show");
        };
        //hàm how data product into edit modal:
        function showProductInfoIntoEditModal(paramProductInfo) {
            $("#input-product-code").val(paramProductInfo.productCode);
            $("#input-product-name").val(paramProductInfo.productName);
            $(".product-image").html(`<img src="${paramProductInfo.imagUrl}" style="width: 150px">`);
            $("#input-description").val(paramProductInfo.description);
            $("#modal-select-country").val(paramProductInfo.countryId);
            $("#modal-select-category").val(paramProductInfo.categoryId);
            $("#input-product-id").val(paramProductInfo.id);
            $("#input-product-price").val(paramProductInfo.price);
            $("#input-product-discount").val(paramProductInfo.discountPrice);


        }
    });

</script>

</html>